//+------------------------------------------------------------------+
//|                                            Expert_Frans_Les1.mq4 |
//|                                      Copyright  2009, Fortuna4x |
//|                                                 www.fortuna4x.nl |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Fortuna4x"
#property link      "www.fortuna4x.nl"

extern int Magic = 2009;
extern int iTakeProfit =20;
extern int iStopLoss = 100;
extern double iLot = 1;

double dSMA5High;
double dSMA5Low;
double LBP;
double dBuyEntry;
string strComment;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 // Delete Pending Buy Orders
  {
  dSMA5High=iMA(NULL,NULL,5,0,MODE_SMA,PRICE_HIGH,0);
  dSMA5Low=iMA(NULL,NULL,5,0,MODE_SMA,PRICE_LOW,0);
  int total = 0;
  if (Close[1]   <= dSMA5Low)
   {
   DeletePendingBuyOrders(Magic);
   }
// Buy Orders sluiten
   LBP = GetLastBuyPrice(Magic);
   if (Bid >= LBP + iTakeProfit*Point || Bid <= LBP-iStopLoss* Point)
   {
   CloseBuyOrders(Magic);
   }
   
// Buy order openen
   if (MyOrdersTotal(Magic)==0)
   {
      if (Close[1] >= dSMA5High)
      dBuyEntry =High[1]+30*Point;
      
      {
       OrderSend(Symbol(),OP_BUYSTOP,iLot,dBuyEntry,3,0,0,"Expert4x",Magic,0,Green);
       strComment= "Pending Buy Order" + "  " +dBuyEntry;
       Comment (strComment);
      }
    }
   return(0);
  }
  
  
  
 // De DeletePendingBuyOrders functie 
  int DeletePendingBuyOrders(int Magic)
  {
  int total = OrdersTotal();
  for (int cnt = total-1; cnt>=0; cnt--)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if (OrderMagicNumber()==Magic && OrderSymbol()==Symbol() &&  (OrderType()==OP_BUYSTOP) &&(OrderType() !=OP_BUY || OrderType() != OP_SELL))
      {
      OrderDelete(OrderTicket());
      Comment("");
      strComment= "Pending Buy Order Deleted " ;
       Comment (strComment);
      }
     }
  return(0);
  }
  
 // De GetLastBuyPrice functie
  double GetLastBuyPrice(int Magic)
  {
  int total = OrdersTotal();
  for (int cnt = total-1; cnt>=0; cnt--)
  {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if (OrderMagicNumber()==Magic && OrderSymbol()==Symbol() && (OrderType() ==OP_BUY ))
   {
   return(OrderOpenPrice());
   break;
   }
  }
  return(0);
  }
  
 
     
   int MyOrdersTotal(int Magic)
   {
      int c = 0;
      int total = OrdersTotal();
  for (int cnt = 0; cnt<total; cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if (OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
      {
      c++;
      }
    }
    return(c);
   }
   // De CloseBuyOrder functie
  int CloseBuyOrders(int Magic)
  {
  int total = OrdersTotal();
  for (int cnt = total-1; cnt>=0; cnt--)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if (OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
      {
      if (OrderType()==OP_BUY)
         {
         OrderClose(OrderTicket(),OrderLots(),Bid,3);
         }
       }
      }
     return(100000);
     }
//+------------------------------------------------------------------+